/*Program - UART - IA2*/
#include <xc.h>
#include <string.h>
__PROG_CONFIG(1,0x3FE4); 	// config. uC (WDT=dis|OSC=int)
__PROG_CONFIG(2,0x3EFF); 	// config. uC (PLL (OSC*4)=off) pag. 130 pdf. PIC16LF1937

unsigned char a, b=0, rec_var;
unsigned char v[10] = {	0xC0,	0xF9, 	0xA4, 	0xB0, 	0x99, 	0x92, 0x82, 0xF8, 0x80, 0x90};
char *logo = (char *) "\r\n Informatica Aplicata 2. Counter = ";

void init (void);
void interrupt ia2(void); // functie de intreruperi globala ptr. TOATE intreruperile
void send_string(const char *buffer, int size);

void main(void)
{
 init();
 while (1)                      // bucla infinita
	 {
		if(a >= 20)             // conditia se indeplineste la: 20*50ms=1sec.
			{
				a = 0;          // ma pregatesc ptr. urmatoarea "secunda"
				PORTB = v[b++];	// du valoarea din vector in PORTB
				if(b>9) b=0;	// citeste vectorul "inca o data"
                send_string("\r\nIA2. Sir caractere = ", strlen("\r\nIA2. Sir caractere = "));
//                send_string(logo, strlen(logo));
                TXREG = b+'0';
			}
        
        if(RCIF)                	// received something on UART?
            {
                rec_var = RCREG;    //bit-ul RCIF se sterge automat cand se citeste RCREG
                TXREG = rec_var+1;  // echo???  :)
            }          
	 }
}

void init (void)
{
	OSCCON=0x73;   	// REGLEAZA OSCILATORUL PE 8 MHz (PLL dezactivat)
    ANSELA = 0x00; 	// pinii portului A sa fie digitali
	TRISA = 0x00;  	// tot portul A este de iesire
	PORTA = 0x00;	// am digit Anod Comun, 
	ANSELB = 0x00; 	// pinii portului B sa fie digitali
	TRISB = 0x00;  	// tot portul B este de iesire
	PORTB = 0x00;	// 
	TRISC = 0b10111111;// RC7=RX=in || RC6=TX=out
	PORTC = 0x00;	//    

/*start UART initialization, without INTERRUPT*/	
    SPBRG   = 12;   // Baud Rate  (viteza transmisie date)
    TXEN    = 1;    // Serial Trasmit Enable
    BRGH    = 0;    // High Baud Rate Transmission
    SPEN    = 1;    // Serial Port Enabled
    CREN    = 1;    // Continuous Receive Enable bit
    BRG16   = 0;    // 16-bit Baud Rate Generator bit
    SYNC    = 0;    // EUSART Mode Select bit [0=Asynchronous mode]
/*end UART initialization*/	
	T1CON = 0x11;  	// initializarea Timer T1
                    // (Fosc/4); prescaler 1:2 => Fosc_timer1=1MHz(T=1us)
	TMR1IE = 1;    	// activez intreruperea ptr. T1
	PEIE = 1;      	// intreruperea T1 face parte din "extra intreruperi"
	GIE = 1;       	// activez Global intreruperile
}

void interrupt ia2(void)            // every 50ms !!!
{                           		//
	if(TMR1IF)          // timerul T1 a generat intreruperea ?
	{
	 	TMR1IF = 0;    	// obligatoriu - sterg flagul Timerului care a generat intreruperea
	 	TMR1H = 0x3C;  	// 65535us-50000us=15535us=3CAF (in hexa) [incarc octetul superior]
	 	TMR1L = 0xAF;  	// (50000us=50ms) [incarc octetul inferior al timerului T1]
		a++;            // la fiecare 50ms se incrementeaza variabila a
	}
}

void send_string(const char *buffer, int size)
{
    while(size)
    {
        TXREG = *buffer;
        while(!TXIF);       // TXIF bit is located in PIR1 register // wait until transmission is completed        
        buffer++;
        size--;
    }
}